package org.kapelle.multiblock;

import org.bukkit.Location;
import org.bukkit.util.BlockVector;

import java.util.List;

public class MultiblockStructure {

    List<List<List<BlockComponent>>> structure;

    public MultiblockStructure(List<List<List<BlockComponent>>> structure){
        this.structure = structure;
    }

    public BlockComponent getComponent(BlockVector offset){
        return getComponent(offset.getBlockX(),offset.getBlockY(),offset.getBlockZ());
    }

    public BlockComponent getComponent(int x, int y, int z){
        return structure.get(x).get(y).get(z);
    }

    public boolean isValid(Location location, BlockVector offset){
        for (int x = 0; x < structure.size(); x++) {
            for (int y = 0; y < structure.get(x).size(); y++) {
                for (int z = 0; z < structure.get(x).get(y).size(); z++) {

                    BlockComponent currentComponent = getComponent(x,y,z);
                    Location globalBlockLocation = location.clone().subtract(offset);

                    if(!currentComponent.isValidBlock(globalBlockLocation)){
                        return false;
                    }
                }
            }
        }

        return true;
    }
}
